<?php

class Get{


    /**
     *   Get data using curl
     *
     *  @param    string   $url
     *  @return   json     data curl_exec
     */
    public function Curl($url) {
	
        $ch = curl_init();
		///curl_setopt($ch, CURLOPT_PROXY, "127.0.0.1:3128");
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); //Set curl to return the data instead of printing it to the browser.
        curl_setopt($ch, CURLOPT_URL, $url);
	    curl_setopt($ch, CURLOPT_HTTPGET, true);
     
	    //Hide all errors
	    Error_reporting(E_All);
	 
        $data = curl_exec($ch);
        curl_close($ch);
     
        return $data;
	  
    }

    /**
     *   Get User json
     *
     *  @param    string - integer   $id
     *  @return   array
     */
    public function get_user($id){

        $pageContent = 'http://api.soundcloud.com/users/'.$id.'.json?client_id='.setting_client_id.'';
        $response    = $this->Curl($pageContent);
        $jsonobj     = json_decode($response);
	        if(!empty($jsonobj->full_name)){
	            $full_name = $jsonobj->full_name;
	        }else{
	            $full_name = $jsonobj->username;
	        }
        $all_info = array(
                    "id" => $jsonobj->id,
                    "kind" => $jsonobj->kind,
                    "permalink" => $jsonobj->permalink,
                    "username" => $jsonobj->username,
                    "uri" => $jsonobj->uri,
                    "permalink_url" => $jsonobj->permalink_url,
                    "avatar_url" => $jsonobj->avatar_url,
                    "country" => $jsonobj->country,
                    "first_name" => $jsonobj->first_name,
                    "last_name" => $jsonobj->last_name,
                    "full_name" => $full_name,
                    "description" => $jsonobj->description,
                    "city" => $jsonobj->city,
                    "discogs_name" => $jsonobj->discogs_name,
                    "myspace_name" => $jsonobj->myspace_name,
                    "website" => $jsonobj->website,
                    "website_title" => $jsonobj->website_title,
                    "online" => $jsonobj->online,
                    "track_count" => $jsonobj->track_count,
                    "playlist_count" => $jsonobj->playlist_count,
                    "plan" => $jsonobj->plan,
                    "public_favorites_count" => $jsonobj->public_favorites_count,
                    "followers_count" => $jsonobj->followers_count,
                    "followings_count" => $jsonobj->followings_count
                    );
                    return $all_info;
    }
							
    /**
     *   Get Data Track
     *
     *  @param    string - integer   $id
     *  @return   object(stdClass)
     */
    public function get_track($id){
	
        $pageContent = 'http://api.soundcloud.com/tracks/'.$id.'.json?client_id='.setting_client_id.'';
        $response    = $this->Curl($pageContent);
        $json_tracks = json_decode($response);
	    return $json_tracks;
    }
			 
    /**
     *   Get Data Search
     *
     *  @param    string - integer   $search_query
     *  @param    integer   $start  (work with pagination class)
     *  @param    integer   $limit  (work with pagination class)
     *  @return   object(stdClass)
     */
    public function get_rows_search($search_query, $start, $limit){
        $off_set     = $start;
        $pageContent = 'http://api.soundcloud.com/tracks.json?q='.$GLOBALS["sys"]->filter_search($search_query).'&client_id='.setting_client_id.'&order=hotness&limit='.$limit.'&offset='.$off_set.'';
	    $response    = $this->Curl($pageContent);
	    $data        = json_decode($response);
	    return $data;
    }
	
    /**
     *   Get data Comments
     *
     *  @param    string - integer   $id_track
     *  @param    integer   $start  (work with pagination class)
     *  @param    integer   $limit  (work with pagination class)
     *  @return   object(stdClass)
     */
    public function get_rows_comments($id_track, $start, $limit){
        $off_set     = $start;
        $pageContent = 'http://api.soundcloud.com/tracks/'.$id_track.'/comments.json?client_id='.setting_client_id.'&limit='.$limit.'&offset='.$off_set.'';
	    $response    = $this->Curl($pageContent);
        $data        = json_decode($response);
        return $data;
    }

    /**
     *   Get Tracks
     *
     *  @param    string - integer   $id_user
     *  @param    integer   $start  (work with pagination class)
     *  @param    integer   $limit  (work with pagination class)
     *  @return   object(stdClass)
     */
    public function get_rows_tracks($id_user, $start, $limit){
        $off_set     = $start;
        $pageContent = 'http://api.soundcloud.com/users/'.$id_user.'/tracks.json?client_id='.setting_client_id.'&limit='.$limit.'&offset='.$off_set.'';
        $response    = $this->Curl($pageContent);
        $tracks      = json_decode($response);
	    return $tracks;

    }
	
    /**
     *   Get DownLoad link - using CURLOPT_FOLLOWLOCATION
     *
     *  @param    integer   $track_id
     *  @return   URL
     */
    public function download($track_id, $op=""){
        $url = 'http://api.soundcloud.com/tracks/'.$track_id.'/stream?client_id='.setting_client_id;
        $ch  = curl_init($url);
		///curl_setopt($ch, CURLOPT_PROXY, "127.0.0.1:3128");
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HEADER, true);
        curl_exec($ch);

        $response = curl_exec($ch);
	    $info     = curl_getinfo($ch);
        preg_match_all('/^Location:(.*)$/mi', $response, $matches);
        curl_close($ch);
		if( empty($op) ){
	        if(!empty($matches[1][0])){
		        $url = str_replace("https://ec-media.soundcloud.com/", "http://media.soundcloud.com/stream/", trim($matches[1][0]));
				$url = str_replace(".128", ".mp3", $url);
				return $url;
	        } else {
		        $url = str_replace("https://ec-media.soundcloud.com/", "http://media.soundcloud.com/stream/", trim($info[redirect_url]));
				$url = str_replace(".128", ".mp3", $url);
				return $url;
	        }
		} else {
	        if(!empty($matches[1][0])){
		        $url = str_replace("https://", "http://", trim($matches[1][0]));
				return $url;
	        } else {
		        $url = str_replace("https://", "http://", trim($info[redirect_url]));
				return $url;
	        }
		}

    }
}

?>
