<?php
class sys{

    /**
     *   Convert to a Normal duration format
     *
     *  @param    integer    $milliseconds
     *  @return   integer    Return Normal duration format
     */
    public function time_convert($milliseconds) {
        $seconds      = floor($milliseconds / 1000);
        $minutes      = floor($seconds / 60);
        $hours        = floor($minutes / 60);
        $milliseconds = $milliseconds % 1000;
        $seconds      = $seconds % 60;
        $minutes      = $minutes % 60;
	    $s_hours      = strlen($hours);
	    $s_minutes    = strlen($minutes);
	    $s_seconds    = strlen($seconds);
        if($s_hours==1){
	        $ch_h = "0"; 
	    } else {
	        $ch_h = "";  
	    }
        if($s_minutes==1){
	        $ch_m = "0"; 
	    } else {
	        $ch_m = ""; 
	    }
        if($s_seconds==1){
	        $ch_s = "0"; 
	    } else {
	        $ch_s = ""; 
	    }
        $time = $ch_h.$hours.":".$ch_m.$minutes.":".$ch_s.$seconds;
        return $time;
    }
   
    /**
     *  Get Gmdate
     *
     *  @param    string    $option
     *  @return   integer    Return Date
     */
    public function da_te($option="today"){
        $option = strtolower($option);
        if($option=="today"){
            $date = gmdate("j-n-Y");
        }
        if($option=="week"){
            $date = gmdate("W-Y");
        }
        if($option=="month"){
            $date = gmdate("n-Y");
        }
        if($option=="year"){
            $date = gmdate("Y");
        }
        return $date;
   }		

    /**
     *   Shorten Text
     *
     *  @param    string    $str - integer   $n
     *  @return   string    Return The Shorten Text
     */
    public function sh_title($str, $n = 30, $end_char = '...'){
        if (strlen($str) < $n)
        {
            return $str;
        }

        $str = preg_replace("/\s+/", ' ', str_replace(array("\r\n", "\r", "\n"), ' ', $str));

        if (strlen($str) <= $n)
        {
            return $str;
        }

        $out = "";
        foreach (explode(' ', trim($str)) as $val)
        {
            $out .= $val.' ';

            if (strlen($out) >= $n)
            {
                $out = trim($out);
                return (strlen($out) == strlen($str)) ? $out : $out.$end_char;
            }       
        }
    }
   
    /**
     *   Get different sizes of images
     *
     *  @param    string    $link containing the query URL.
     *  @return   string    Return The new url for Image
     */											   
    public function img($link, $op="100", $another=""){
        $default_av = substr(basename($another), 0, 24);
        $default_av_old = substr(basename($another), 0, 37);
        if($op=="500"){
            $size = "t500x500";
        } else if($op=="400"){
            $size = "crop";
        } else if($op=="300"){
            $size = "t300x300";
       } else if($op=="100"){
            $size = "large";
        } else if($op=="67"){
            $size = "t67x67";
        } else if($op=="47"){
            $size = "badge";
        } else if($op=="32"){
            $size = "small";
        } else if($op=="20"){
            $size = "tiny";
        } else if($op=="18"){
            $size = "tiny";
        } else if($op=="16"){
            $size = "mini";
        } else if($op=="original"){
            $size = "original";
        } else {
            $size = "large";
        }
        $image = str_replace("large", $size, $link);
        $image = str_replace("default_avatar_".$size, "default_avatar_large", $image);
        $image = str_replace("https://", "http://", $image);
            // replace the Old SoundCloud image
            if(empty($link) && !empty($another) && $default_av!="default_avatar_large.png" && $default_av_old!="avatars-000053235316-425dvx-large.jpg"){
                $image1 = str_replace("large", $size, $another);
                $image1 = str_replace("https://", "http://", $image1);
                return $image1;
            } else if(!empty($image)){
                return $image;
            } else {
                $default_image = $this->get_url()."template/images/default-image.png";
                return $default_image;
            }
    }   
   
    /**
     *   remove https and replace it with http
     *
     *  @param    string    $link containing the query URL.
     *  @return   string    Return The new url without https://
     */
    public function to_http($link){
        $link = str_replace("https://", "http://", $link);
        return $link;
    }
   
    /**
     *   cleaning date
     *
     *  @param    string    $date like "2014/03/17 12:55:50 +0000"
	 *  @param    string    $op full,date,time
     *  @return   string    Return The new date 
	 *  full: 2014/03/17 12:55:50 - date: 2014/03/17 - time: 12:55:50
     */
    public function clean_date($date, $op="full"){
	    $full_date = str_replace("+0000", "", $date);
	    $date      = substr($full_date, 0, 10);
	    $hour      = substr(trim(str_replace($date, "", $full_date)), 0, 5);
	    if($op=="full"){
	        return $full_date;
	    } else if($op=="date"){
	        return $date;
	    } else if($op=="time"){
	        return $hour;
	    } else {
	        return $full_date;
	    }
    }
   
    /**
     *   Generating  numbers of stars by using playback count
     *
     *  @param    integer    $playback
     *  @return   integer    Return a number between 1-5
	 *  - Or -
     *  @return   html content
     */
    public function get_stars($playback="0", $op=""){
        if($playback > "1000000"){
	    $number_of_stars = "5";
	    }
	    else if($playback > "100000"){
	    $number_of_stars = "4";
	    }
	    else if($playback > "10000"){
	    $number_of_stars = "3";
	    }
	    else if($playback > "1000"){
	    $number_of_stars = "2";
	    }
	    else if($playback > "10"){
	    $number_of_stars = "1";
	    }
	    else{
	    $number_of_stars = "1";
	    }
	    $not_rated = 5-$number_of_stars;
	    $rate = '<li class="rated"></li>';
	    $norate = '<li></li>';
	    $returned = "";
	        for($i=0;$i<$number_of_stars;$i++){
	            $returned .= $rate;
	        }
	        for($i=0;$i<$not_rated;$i++){
	            $returned .= $norate;
	        }
	    if(!empty($op)){
	        return $number_of_stars;
	    } else {
	        return $returned;
	    }
    }
      
    /**
     *   Generate real link
     *
     *  @param    string    $op (full,dir,track,artist)
	 *  @param    string or integer   $id
	 *  @param    string   $prtcl http:// , https://
     *  @return   string    Return The real link 
     */
    public function get_url($op="full", $id="", $prtcl="http://"){
        $dir  = $_SERVER[SCRIPT_NAME];
        $base = basename($_SERVER[SCRIPT_NAME]);
        $dir  = str_replace($base, "", $dir);
        $url  = $prtcl.$_SERVER[HTTP_HOST].$dir;
        if($op=="full"){
            return $url;
        } else if($op=="dir"){
	        return $dir;
        } else if($op=="track" && !empty($id)){
	        return $url."listen/".$id;
        } else if($op=="artist" && !empty($id)){
	        return $url."artist/".$id;
        }
    }
	
    /**
     *   Get Languages Values 
     *
     *  @param    string    $op
	 *  @param    string    $style (one,full)
     *  @return   string    all values (or) one value
     */
    public function lng($op, $style="one"){
        $lng_cookie = strip_tags($_COOKIE['lng']);
        $sd = scandir("langs/");
        if(in_array(!empty($lng_cookie) && $lng_cookie, $sd)  && $lng_cookie!="." && $lng_cookie!=".." && $lng_cookie!="index.html"){
            $l= $lng_cookie;
        }else{
            $l= setting_default_lng;
        }
     	$file = "langs/".$l."/lng.json";
		$fh_lng = fopen($file, 'r');
		$language = fread($fh_lng, filesize($file));
		$decode_lng = json_decode($language);
		if($style=="one"){
		    return $decode_lng->$op;
		}
		if($style=="all"){ 
		    $array = json_decode(json_encode($decode_lng), true);
		    return $array;
		}
		  
    }	

    /**
     *   Get the languages ​​available
     *
     *  @return   array (all languages ex: array("english", "arabic") )
     */
    public function fetch_languages(){
        $lng_cookie = strip_tags($_COOKIE['lng']);
        $sd = scandir("langs/");
        $scan = array_diff($sd, array(".","..", "index.html"));
            foreach($scan as $language){
                $file = "langs/".$language."/lng.json";
                $fh_lng = fopen($file, 'r');
                $language_getting = fread($fh_lng, filesize($file));
                $decode_lng = json_decode($language_getting);
                $new[$language] = $decode_lng->name;
            }
        return $new;
    }
   
    /**
     *  Generating expressive word for song by using playbacks && comments
     *
     *  @param    integer    $playbacks
	 *  @param    integer    $comments
     *  @return   string     an expressive word for song
     */
    public function get_views($playbacks="0", $comments="0"){
        $v_p   =  $this->get_stars($playbacks, "number");
        $v_c   =  $this->get_stars($comments, "number");
        $views = $v_p+$v_c;
        $v_ar  = array(
        "v_1", "v_1", "v_2", "v_3", "v_4", "v_5", "v_5", "v_6", "v_7", "v_8", "v_9"
             );
        return $this->lng($v_ar[$views]);
    }
   
    /**
     *  set Language
     *
     *  @param    string    $lng
     *  @return   setcookie - set New language
     */
    public function setlang($lng){
        $sd = scandir("langs/");
        if(in_array($lng, $sd)  && $lng!="." && $lng!=".." && $lng!="index.html"){
            $l= $lng;
        } else {
            $l="en";
        }
     setcookie("lng", $l, time()+860000 );
    }	
   
    /**
     *  change language
     *
     *  @return   call previous function and change Language
     */
    public function change_lang(){
        if(!empty($_GET['lang'])){
            $new_lng = strip_tags($_GET['lang']);
            $this->setlang($new_lng);
            $url_ref = $_SERVER['HTTP_REFERER'];
            $fil = parse_url($url_ref);
            $j_url = $fil[scheme]."://".$fil[host].$this->get_url("dir");
            if(!empty($url_ref) && $j_url==$this->get_url()){
                header("location: ".$url_ref);
            } else {
                header("location: ".$this->get_url());
            }
        }
    }

    /**
     *  Redir any search without (pjax)
     *
     *  @return   redir to /search/$.searchquery.$
     */
    public function search_redir(){
        if(!empty($_POST['dosearch'])){
	        $search_query = urlencode(strip_tags($_POST['dosearch']));
	        $search_query = str_replace("%2F", " ", $search_query);
	        $search_query = urlencode($search_query);
            header("location: ".$this->get_url()."search/".$search_query);
        }
   }

    /**
     *  Send New Password Using mail function
     *
     *  @param    string    $email setting_email
     *  @param    string    $to 
     *  @param    string    $newpass 
     *  @return   true or false - Send a New Password
     */
    public function send_message($email, $to="", $newpass=""){
   
        $email   = strip_tags($email);
        $message = strip_tags($newpass);
        $to      = strip_tags($to);
   
	    $mess = "
	    ".$this->lng('alert_mail_subject1')."
	    ".$this->lng('alert_mail_subject2')." : ".$message."
	    ".$this->lng('title_login')." : ".$this->get_url()."user/login
	    ";
	    $sub = $this->lng('alert_mail_subject1');
	    $headers = "From:" . $email;
	    $mail = mail($to,$sub,$mess,$headers);
	
	    if($mail){
	        return true;
	    } else {
	        return false;
	    }
    }
   
    /**
     *  filter search query
	 *
     *  @param    string  $search
     *
     *  @return   string
     */
    public function filter_search($search){
        $text = strip_tags($search);
		$text = str_replace("=", urlencode("="), $text);
		$text = str_replace("?", urlencode("?"), $text);
		$text = str_replace("&", urlencode("&"), $text);
		$text = stripslashes($text);
		return $text;
    }
   
    /**
     *  Check if cookies are enabled
     *
     *  @return   true or false
     */
    public function check_cookie(){
        setcookie("check", "Yes", time()+86000, $this->get_url("dir"));
        if(isset($_COOKIE['check'])){
            return true;
        }else{
            return false;
        }
    }

}

?>